import sys
if sys.version_info >= (3, 6):
	from enum import Enum, IntFlag
else:
	from aenum import Enum, IntFlag

WH_KEYBOARD_LL = 13
WH_MOUSE_LL = 14

PM_REMOVE = 0x0001

LLKHF_INJECTED = 0x00000010
LLMHF_INJECTED = 0x00000001

XBUTTON1 = 0x0001
XBUTTON2 = 0x0002
WHEEL_DELTA = 120

SM_CXSCREEN = 0
SM_CYSCREEN = 1

WM_HOTKEY = 0x0312
WM_CLOSE = 0x0010

OBJID_WINDOW = 0x00000000


class MouseWM(int, Enum):

	WM_MOUSEMOVE = 0x200
	WM_LBUTTONDOWN = 0x201
	WM_LBUTTONUP = 0x202
	WM_RBUTTONDOWN = 0x204
	WM_RBUTTONUP = 0x205
	WM_MBUTTONDOWN = 0x207
	WM_MBUTTONUP = 0x208
	WM_MOUSEWHEEL = 0x20A
	WM_MOUSEHWHEEL = 0x20E
	WM_XBUTTONDOWN = 0x020B
	WM_XBUTTONUP = 0x020C


class InputType(int, Enum):

	MOUSE = 0
	KEYBOARD = 1
	HARDWARE = 2


class MOUSEEVENTF(IntFlag):

	ABSOLUTE = 0x8000
	HWHEEL = 0x01000
	MOVE = 0x0001
	MOVE_NOCOALESCE = 0x2000
	LEFTDOWN = 0x0002
	LEFTUP = 0x0004
	RIGHTDOWN = 0x0008
	RIGHTUP = 0x0010
	MIDDLEDOWN = 0x0020
	MIDDLEUP = 0x0040
	VIRTUALDESK = 0x4000
	WHEEL = 0x0800
	XDOWN = 0x0080
	XUP = 0x0100


class KeyWM(int, Enum):

	WM_KEYDOWN = 0x0100
	WM_KEYUP = 0x0101
	WM_SYSKEYDOWN = 0x0104
	WM_SYSKEYUP = 0x0105
	WM_CHAR = 0x0102


class MOD(IntFlag):

	ALT = 0x0001
	CTRL = 0x0002
	SHIFT = 0x0004
	META = 0x0008


class KEYEVENTF(IntFlag):

	KEYUP = 0x0002
	SCANCODE = 0x0008
	UNICODE = 0x0004


class EVENT(int, Enum):

	MIN = 0x00000001
	MAX = 0x7FFFFFFF
	OBJECT_CREATE = 0x8000
	OBJECT_DESTROY = 0x8001
	SYSTEM_FOREGROUND = 0x0003


class WINEVENT(IntFlag):

	OUTOFCONTEXT = 0x0000
	SKIPOWNTHREAD = 0x0001
	SKIPOWNPROCESS = 0x0002


class GA(IntFlag):

	PARENT = 1
	ROOT = 2
	ROOTOWNER = 3


class SW(int, Enum):

	HIDE = 0
	MAXIMIZE = 3
	MINIMIZE = 6
	RESTORE = 9
	SHOW = 5
	SHOWMAXIMIZED = 3
	SHOWMINIMIZED = 2
	SHOWMINNOACTIVE = 7
	SHOWNA = 8
	SHOWNOACTIVATE = 4
	SHOWNORMAL = 1

class MK(IntFlag):

	CONTROL = 0x0008
	LBUTTON = 0x0001
	MBUTTON = 0x0010
	RBUTTON = 0x0002
	SHIFT = 0x0004
	XBUTTON1 = 0x0020
	XBUTTON2 = 0x0040
